Page MenuHomePhabricator

[OpenMP] Add support for close map modifier in Clang
ClosedPublic

Authored by gtbercea on Jul 26 2019, 10:58 AM.

Details

Summary

This patch adds support for the close map modifier in Clang.

This ensures that the new map type is marked and passed to the OpenMP runtime appropriately.

Additional regression tests have been merged from patch D55892 (author @saghir).

Diff Detail

Repository
rL LLVM

Event Timeline

gtbercea created this revision.Jul 26 2019, 10:58 AM
Herald added a project: Restricted Project. · View Herald Transcript
ABataev added inline comments.Jul 26 2019, 10:59 AM
lib/CodeGen/CGOpenMPRuntime.cpp
7695 ↗(On Diff #211969)

Why?

gtbercea marked 2 inline comments as done.Jul 26 2019, 12:36 PM
gtbercea added inline comments.
lib/CodeGen/CGOpenMPRuntime.cpp
7695 ↗(On Diff #211969)

If the pointee has been mapped as TO/FROM/etc already no need to map it TO/FROM/etc again.

gtbercea marked an inline comment as done.Jul 26 2019, 12:36 PM
gtbercea updated this revision to Diff 212011.Jul 26 2019, 2:54 PM
  • Improve test.
This revision is now accepted and ready to land.Jul 29 2019, 6:45 AM
Hahnfeld requested changes to this revision.Jul 29 2019, 7:06 AM
Hahnfeld added subscribers: saghir, Hahnfeld.

There's already D55892 with a better set of tests, including target enter data / target exit data.

This revision now requires changes to proceed.Jul 29 2019, 7:06 AM

There's already D55892 with a better set of tests, including target enter data / target exit data.

Better to merge those two patches into one.

There's already D55892 with a better set of tests, including target enter data / target exit data.

Better to merge those two patches into one.

How would you like me to proceed? It looks like the other patch has been sitting there approved for many many months.

kkwli0 added a subscriber: kkwli0.Jul 29 2019, 8:31 AM

There's already D55892 with a better set of tests, including target enter data / target exit data.

Better to merge those two patches into one.

How would you like me to proceed? It looks like the other patch has been sitting there approved for many many months.

Yes, the patch has been waiting for the runtime implementation first and then commit.

There's already D55892 with a better set of tests, including target enter data / target exit data.

Better to merge those two patches into one.

How would you like me to proceed? It looks like the other patch has been sitting there approved for many many months.

Yes, the patch has been waiting for the runtime implementation first and then commit.

The runtime implementation is here: D65340

There's already D55892 with a better set of tests, including target enter data / target exit data.

Better to merge those two patches into one.

How would you like me to proceed? It looks like the other patch has been sitting there approved for many many months.

Yes, the patch has been waiting for the runtime implementation first and then commit.

I am not sure if it is easier to rebase D55892 and merge this patch to D55892. I am okay to go either way.

gtbercea updated this revision to Diff 212821.Aug 1 2019, 8:03 AM
  • Improve test.
  • Add tests from previous patch.
gtbercea edited the summary of this revision. (Show Details)Aug 1 2019, 8:05 AM
gtbercea added a reviewer: kkwli0.
gtbercea edited the summary of this revision. (Show Details)

@Hahnfeld I have merged the tests from the previous patch as per Alexey's suggestion - with minor changes to make them pass. Let me know if this now addresses your previous comments.

kkwli0 added a comment.Aug 1 2019, 9:00 AM

Looks fine to me.

Hahnfeld added inline comments.
lib/CodeGen/CGOpenMPRuntime.cpp
7695 ↗(On Diff #211969)

I'm not sure if there's a test for this. I can't verify right now, so I trust you that it's covered.

This revision is now accepted and ready to land.Aug 1 2019, 9:38 AM
gtbercea marked an inline comment as done.Aug 1 2019, 11:02 AM
gtbercea added inline comments.
lib/CodeGen/CGOpenMPRuntime.cpp
7695 ↗(On Diff #211969)

I added the test as per Alexey's previous request.

This revision was automatically updated to reflect the committed changes.
Herald added a project: Restricted Project. · View Herald TranscriptAug 9 2019, 2:45 PM